<div class="full-width full-height flex-column neutral-background-color">
  <div
    class="m-5 font-20-px flex-fixed-size flex-row"
    [attr.data-test-toolbar-id]="'custom-report-toolbar'"
  >
    <span>
      @if (canCreateSomething$ | async) {
        <i
          nz-icon
          nz-dropdown
          [nzDropdownMenu]="creationMenu"
          nzType="sqtm-core-tree:add"
          nzTheme="outline"
          class="current-workspace-button action-icon-size"
          [attr.data-test-toolbar-button-id]="'create-button'"
        >
        </i>
      } @else {
        <i
          nz-icon
          nzType="sqtm-core-tree:add"
          nzTheme="outline"
          class="label-color action-icon-size"
          [attr.data-test-toolbar-button-id]="'create-button'"
        ></i>
      }
    </span>
    <sqtm-core-toggle-icon
      class="m-l-30"
      [attr.data-test-toolbar-button-id]="'copy-button'"
      [active]="tree.canCopy$ | async"
      (clickedInActiveMode)="copy()"
    >
      <i
        nz-icon
        nzType="sqtm-core-generic:copy"
        nzTheme="outline"
        nz-tooltip
        [nzTooltipTitle]="'sqtm-core.generic.label.copy' | translate"
        nzTooltipPlacement="bottom"
        class="action-icon-size"
      ></i>
    </sqtm-core-toggle-icon>
    <sqtm-core-toggle-icon
      class="m-l-10"
      [attr.data-test-toolbar-button-id]="'paste-button'"
      [active]="tree.canPaste$ | async"
      (clickedInActiveMode)="paste()"
    >
      <i
        nz-icon
        nzType="sqtm-core-generic:paste"
        nzTheme="outline"
        nz-tooltip
        class="action-icon-size"
        [nzTooltipTitle]="
          'sqtm-core.generic.label.paste-with-shortcut' | translate
        "
        nzTooltipPlacement="bottom"
      ></i>
    </sqtm-core-toggle-icon>

    @if (referentialDataService.canDeleteFromFront$ | async) {
      <sqtm-core-toggle-icon
        class="m-l-10"
        [attr.data-test-toolbar-button-id]="'delete-button'"
        [active]="tree.canDelete$ | async"
        (clickedInActiveMode)="delete()"
      >
        <i
          nz-icon
          nzType="sqtm-core-generic:delete"
          nzTheme="outline"
          nz-tooltip
          class="action-icon-size"
          [nzTooltipTitle]="
            'sqtm-core.generic.label.delete-with-shortcut' | translate
          "
          nzTooltipPlacement="bottom"
        ></i>
      </sqtm-core-toggle-icon>
    }

    <span class="m-l-auto m-r-20">
      <i
        nz-icon
        nzType="sqtm-core-generic:settings"
        nzTheme="outline"
        nz-popover
        [nzPopoverContent]="settingsMenu"
        class="current-workspace-button action-icon-size"
        [attr.data-test-toolbar-button-id]="'settings-button'"
      ></i>
    </span>
  </div>
  <div class="full-height full-width" sqtmCoreTreeKeyboardShortcut>
    <sqtm-core-grid
      class="sqtm-core-prevent-selection-in-grid"
    ></sqtm-core-grid>
  </div>
</div>

<nz-dropdown-menu #creationMenu="nzDropdownMenu">
  @if (createMenuPermissions$ | async; as perms) {
    <ul nz-menu [attr.data-test-menu-id]="'create-menu'">
      <li
        nz-menu-item
        [attr.data-test-menu-item-id]="'new-folder'"
        [nzDisabled]="!perms.canCreateFolder"
        (click)="openCreateFolder(perms.canCreateFolder)"
      >
        {{ 'sqtm-core.test-case-workspace.tree.button.new-folder' | translate }}
      </li>
      <li
        nz-menu-item
        [nzDisabled]="!perms.canCreateChart"
        [attr.data-test-menu-item-id]="'new-chart-definition'"
        (click)="navigateToCreateChartView(perms.canCreateChart)"
      >
        {{
          'sqtm-core.custom-report-workspace.tree.button.new-chart-definition'
            | translate
        }}
      </li>
      <li
        nz-menu-item
        [nzDisabled]="!perms.canCreateReport"
        [attr.data-test-menu-item-id]="'new-report-definition'"
        (click)="navigateToCreateReportView(perms.canCreateReport)"
      >
        {{
          'sqtm-core.custom-report-workspace.tree.button.new-report-definition'
            | translate
        }}
      </li>
      <li
        nz-menu-item
        [attr.data-test-menu-item-id]="'new-dashboard'"
        [nzDisabled]="!perms.canCreateDashboard"
        (click)="addDashboard(perms.canCreateDashboard)"
      >
        {{
          'sqtm-core.custom-report-workspace.tree.button.new-dashboard'
            | translate
        }}
      </li>
      <li
        nz-menu-item
        [attr.data-test-menu-item-id]="'new-custom-export'"
        [nzDisabled]="!perms.canCreateCustomExport"
        (click)="navigateToCreateCustomExportView(perms.canCreateCustomExport)"
      >
        {{
          'sqtm-core.custom-report-workspace.tree.button.new-custom-export'
            | translate
        }}
      </li>
    </ul>
  }
</nz-dropdown-menu>

<ng-template #settingsMenu>
  <span class="current-workspace-main-color sqtm-tree-configuration-title">
    <div
      style="display: flex; justify-content: center"
      [attr.data-test-menu-id]="'collapse'"
    >
      <button
        nz-button
        nzType="primary"
        [attr.data-test-menu-item-id]="'collapse-tree'"
        [disabled]="!(canBeCollapsed$ | async)"
        (click)="collapseTree()"
      >
        {{ 'sqtm-core.tree-picker.generic.collapse-tree.label' | translate }}
      </button>
    </div>
  </span>
  <div class="spacer m-b-10"></div>
  <span class="current-workspace-main-color sqtm-tree-configuration-title">{{
    'sqtm-core.tree-picker.generic.configuration.truncate-too-long-names.title'
      | translate
  }}</span>
  <div [attr.data-test-menu-id]="'truncate-menu'">
    <nz-radio-group
      [(ngModel)]="truncateNameValue"
      (ngModelChange)="changeEllipsisDirection()"
    >
      <label
        nz-radio
        nzValue="TO-THE-RIGHT"
        [attr.data-test-menu-item-id]="'truncate-to-the-right'"
        >{{
          'sqtm-core.tree-picker.generic.configuration.truncate-too-long-names.to-the-right'
            | translate
        }}</label
      >
      <label
        nz-radio
        nzValue="TO-THE-LEFT"
        [attr.data-test-menu-item-id]="'truncate-to-the-left'"
        >{{
          'sqtm-core.tree-picker.generic.configuration.truncate-too-long-names.to-the-left'
            | translate
        }}</label
      >
    </nz-radio-group>
  </div>
</ng-template>
